package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.components.EditBox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.Minecraft;

import net.mcreator.puzzle_code.world.inventory.AreaCodeBlockGUIAreaMenu;
import net.mcreator.puzzle_code.procedures.ReturnSecondAreaPositionCodeBlockProcedure;
import net.mcreator.puzzle_code.procedures.ReturnFirstAreaPositionCodeBlockProcedure;
import net.mcreator.puzzle_code.procedures.ReturnCurrentSelectedAxisProcedure;
import net.mcreator.puzzle_code.procedures.ReturnCurrentNBTAreaCodeBlockProcedure;
import net.mcreator.puzzle_code.procedures.ReturnCurrentCoordinateProcedure;
import net.mcreator.puzzle_code.procedures.ReturnCurrentAxisValueAreaProcedure;
import net.mcreator.puzzle_code.network.AreaCodeBlockGUIAreaButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class AreaCodeBlockGUIAreaScreen extends AbstractContainerScreen<AreaCodeBlockGUIAreaMenu> {
	private final static HashMap<String, Object> guistate = AreaCodeBlockGUIAreaMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	EditBox positionField;
	Button button_x;
	Button button_y;
	Button button_z;
	Button button_1;
	Button button_2;
	Button button_back;
	ImageButton imagebutton_enter_button;
	ImageButton imagebutton_edit_button;
	ImageButton imagebutton_swap_button;

	public AreaCodeBlockGUIAreaScreen(AreaCodeBlockGUIAreaMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 159;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("puzzle_code:textures/screens/area_code_block_gui_area.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		positionField.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
		if (mouseX > leftPos + 146 && mouseX < leftPos + 166 && mouseY > topPos + 111 && mouseY < topPos + 131)
			guiGraphics.renderTooltip(font, Component.translatable("gui.puzzle_code.area_code_block_gui_area.tooltip_flips_the_current_selected_axis"), mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		if (positionField.isFocused())
			return positionField.keyPressed(key, b, c);
		return super.keyPressed(key, b, c);
	}

	@Override
	public void resize(Minecraft minecraft, int width, int height) {
		String positionFieldValue = positionField.getValue();
		super.resize(minecraft, width, height);
		positionField.setValue(positionFieldValue);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font,

				ReturnCurrentSelectedAxisProcedure.execute(world, x, y, z), 146, 57, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.area_code_block_gui_area.label_nbt"), 6, 30, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.area_code_block_gui_area.label_nbt_currentselectedaxis"), 6, 57, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnCurrentNBTAreaCodeBlockProcedure.execute(world, x, y, z), 29, 30, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnCurrentAxisValueAreaProcedure.execute(world, x, y, z), 6, 44, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.area_code_block_gui_area.label_nbt_currentposition"), 6, 71, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnCurrentCoordinateProcedure.execute(world, x, y, z), 132, 71, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnFirstAreaPositionCodeBlockProcedure.execute(world, x, y, z), 6, 84, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnSecondAreaPositionCodeBlockProcedure.execute(world, x, y, z), 6, 98, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		positionField = new EditBox(this.font, this.leftPos + 7, this.topPos + 9, 111, 18, Component.translatable("gui.puzzle_code.area_code_block_gui_area.positionField"));
		positionField.setMaxLength(32767);
		guistate.put("text:positionField", positionField);
		this.addWidget(this.positionField);
		button_x = Button.builder(Component.translatable("gui.puzzle_code.area_code_block_gui_area.button_x"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new AreaCodeBlockGUIAreaButtonMessage(0, x, y, z));
				AreaCodeBlockGUIAreaButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 6, this.topPos + 111, 18, 20).build();
		guistate.put("button:button_x", button_x);
		this.addRenderableWidget(button_x);
		button_y = Button.builder(Component.translatable("gui.puzzle_code.area_code_block_gui_area.button_y"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new AreaCodeBlockGUIAreaButtonMessage(1, x, y, z));
				AreaCodeBlockGUIAreaButtonMessage.handleButtonAction(entity, 1, x, y, z);
			}
		}).bounds(this.leftPos + 29, this.topPos + 111, 18, 20).build();
		guistate.put("button:button_y", button_y);
		this.addRenderableWidget(button_y);
		button_z = Button.builder(Component.translatable("gui.puzzle_code.area_code_block_gui_area.button_z"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new AreaCodeBlockGUIAreaButtonMessage(2, x, y, z));
				AreaCodeBlockGUIAreaButtonMessage.handleButtonAction(entity, 2, x, y, z);
			}
		}).bounds(this.leftPos + 51, this.topPos + 111, 18, 20).build();
		guistate.put("button:button_z", button_z);
		this.addRenderableWidget(button_z);
		button_1 = Button.builder(Component.translatable("gui.puzzle_code.area_code_block_gui_area.button_1"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new AreaCodeBlockGUIAreaButtonMessage(3, x, y, z));
				AreaCodeBlockGUIAreaButtonMessage.handleButtonAction(entity, 3, x, y, z);
			}
		}).bounds(this.leftPos + 74, this.topPos + 111, 31, 20).build();
		guistate.put("button:button_1", button_1);
		this.addRenderableWidget(button_1);
		button_2 = Button.builder(Component.translatable("gui.puzzle_code.area_code_block_gui_area.button_2"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new AreaCodeBlockGUIAreaButtonMessage(4, x, y, z));
				AreaCodeBlockGUIAreaButtonMessage.handleButtonAction(entity, 4, x, y, z);
			}
		}).bounds(this.leftPos + 110, this.topPos + 111, 31, 20).build();
		guistate.put("button:button_2", button_2);
		this.addRenderableWidget(button_2);
		button_back = Button.builder(Component.translatable("gui.puzzle_code.area_code_block_gui_area.button_back"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new AreaCodeBlockGUIAreaButtonMessage(5, x, y, z));
				AreaCodeBlockGUIAreaButtonMessage.handleButtonAction(entity, 5, x, y, z);
			}
		}).bounds(this.leftPos + 6, this.topPos + 134, 162, 20).build();
		guistate.put("button:button_back", button_back);
		this.addRenderableWidget(button_back);
		imagebutton_enter_button = new ImageButton(this.leftPos + 146, this.topPos + 8, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/enter_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/enter_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new AreaCodeBlockGUIAreaButtonMessage(6, x, y, z));
						AreaCodeBlockGUIAreaButtonMessage.handleButtonAction(entity, 6, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_enter_button", imagebutton_enter_button);
		this.addRenderableWidget(imagebutton_enter_button);
		imagebutton_edit_button = new ImageButton(this.leftPos + 123, this.topPos + 8, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/edit_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/edit_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new AreaCodeBlockGUIAreaButtonMessage(7, x, y, z));
						AreaCodeBlockGUIAreaButtonMessage.handleButtonAction(entity, 7, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_edit_button", imagebutton_edit_button);
		this.addRenderableWidget(imagebutton_edit_button);
		imagebutton_swap_button = new ImageButton(this.leftPos + 146, this.topPos + 111, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/swap_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/swap_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new AreaCodeBlockGUIAreaButtonMessage(8, x, y, z));
						AreaCodeBlockGUIAreaButtonMessage.handleButtonAction(entity, 8, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_swap_button", imagebutton_swap_button);
		this.addRenderableWidget(imagebutton_swap_button);
	}
}
